"use strict";

let ctx = null;
let clickDown = false;

main();

function main() {

  // Init canvas
  const canvasElement = document.querySelector('canvas');
  ctx = canvasElement.getContext('2d');

  var rect = canvasElement.parentNode.getBoundingClientRect();
  ctx.canvas.width = rect.width;
  ctx.canvas.height = rect.height;

  ctx.canvas.width = window.innerWidth*9/10;
  ctx.canvas.height = 600;

  setMouseListener();
  setDrawingParamListener();
  
}

function setMouseListener() {
  const canvasElement = document.querySelector('canvas');
  canvasElement.addEventListener('mousedown', mouseDownAction);
  canvasElement.addEventListener('mouseup',   mouseUpAction);
  canvasElement.addEventListener('mousemove', mouseMoveAction);
}

function setDrawingParamListener() {
  const penColorElement = document.querySelector('#pen-color');
  penColorElement.addEventListener('input', colorPenAction);

  const penWidthElement = document.querySelector('#pen-width');
  penWidthElement.addEventListener('input', colorWidthAction);

  const backgroundColorElement = document.querySelector('#background-color');
  backgroundColorElement.addEventListener('input', backgroundColorAction);
}


function colorPenAction(event) {
  ctx.strokeStyle = event.currentTarget.value;
}

function colorWidthAction(event) {
  ctx.lineWidth = event.currentTarget.value;
}

function backgroundColorAction(event) {
  const canvasElement = document.querySelector('canvas');
  canvasElement.style.backgroundColor = event.currentTarget.value;
}

function mouseDownAction(event) {
    clickDown = true;
    const x = event.offsetX;
    const y = event.offsetY;
    ctx.beginPath();
}

function mouseUpAction(event) {
    clickDown = false;
}

function mouseMoveAction(event) {
  
  if( clickDown===true ) {
    const x = event.offsetX;
    const y = event.offsetY;

    ctx.lineTo(x,y);
    ctx.stroke();
  }

}

